ConRO.Warrior = {};
ConRO.Warrior.CheckTalents = function()
end
local ConRO_Warrior, ids = ...;

function ConRO:EnableRotationModule(mode)
	mode = mode or 1;
	self.ModuleOnEnable = ConRO.Warrior.CheckTalents;
	if mode == 1 then
		self.Description = 'Warrior [Arms - Melee]';
		self.NextSpell = ConRO.Warrior.Arms;
		self.ToggleDamage();
	end;
	if mode == 2 then
		self.Description = 'Warrior [Fury - Melee]';
		self.NextSpell = ConRO.Warrior.Fury;
		self.ToggleDamage();
	end;
	if mode == 3 then
		self.Description = 'Warrior [Protection - Tank]';
		self.NextSpell = ConRO.Warrior.Protection;
		self.ToggleDamage();
	end;
	self:RegisterEvent('UNIT_SPELLCAST_SUCCEEDED');
	self.lastSpellId = 0;	
end

function ConRO:EnableDefenseModule(mode)
	mode = mode or 1;
	self.ModuleOnEnable = ConRO.Warrior.CheckTalents;
	if mode == 1 then
		self.NextDef = ConRO.Warrior.ArmsDef;
	end;
	if mode == 2 then
		self.NextDef = ConRO.Warrior.FuryDef;
	end;
	if mode == 3 then
		self.NextDef = ConRO.Warrior.ProtectionDef;
	end;
end

function ConRO:UNIT_SPELLCAST_SUCCEEDED(event, unitID, lineID, spellID)
	if unitID == 'player' then
		self.lastSpellId = spellID;
	end
end

function ConRO.Warrior.Arms(_, timeShift, currentSpell, gcd, tChosen)
--Resources	
	local rage 												= UnitPower('player', Enum.PowerType.Rage);
	local rageMax 											= UnitPowerMax('player', Enum.PowerType.Rage);

--Racials
	local arctorrent										= ConRO:AbilityReady(ids.Racial.ArcaneTorrent, timeShift);

--Abilities	
	local pummel											= ConRO:AbilityReady(ids.Arms_Ability.Pummel, timeShift);
	local bshout											= ConRO:AbilityReady(ids.Arms_Ability.BattleShout, timeShift);
	local hthrow											= ConRO:AbilityReady(ids.Arms_Ability.HeroicThrow, timeShift);	
	local csmash, csCD										= ConRO:AbilityReady(ids.Arms_Ability.ColossusSmash, timeShift);
		local csDebuff											= ConRO:TargetAura(ids.Arms_Debuff.ColossusSmash, timeShift);
	local mstrike											= ConRO:AbilityReady(ids.Arms_Ability.MortalStrike, timeShift);
		local dwDebuff											= ConRO:TargetAura(ids.Arms_Debuff.DeepWounds, timeShift + 1.5);
	local charge 											= ConRO:AbilityReady(ids.Arms_Ability.Charge, timeShift);
		local inChRange 										= ConRO:IsSpellInRange(GetSpellInfo(ids.Arms_Ability.Charge), 'target');
	local slam 												= ConRO:AbilityReady(ids.Arms_Ability.Slam, timeShift);
	local ww 												= ConRO:AbilityReady(ids.Arms_Ability.Whirlwind, timeShift);
	local bstorm 											= ConRO:AbilityReady(ids.Arms_Ability.Bladestorm, timeShift);
	local exe												= ConRO:AbilityReady(ids.Arms_Ability.Execute, timeShift);
		local mexeCD 											= ConRO:Cooldown(ids.Arms_Talent.MassacreExecute, timeShift);
		local sdBuff											= ConRO:Aura(ids.Arms_Buff.SuddenDeath, timeShift);
	local opower											= ConRO:AbilityReady(ids.Arms_Ability.Overpower, timeShift);
		local opCharges											= ConRO:SpellCharges(ids.Arms_Ability.Overpower);
		local opBuff, opBCount									= ConRO:Aura(ids.Arms_Buff.Overpower, timeShift);
	local sstrikes											= ConRO:AbilityReady(ids.Arms_Ability.SweepingStrikes, timeShift);
		local ssBuff											= ConRO:Aura(ids.Arms_Buff.SweepingStrikes, timeShift);
		
	local ssplit											= ConRO:AbilityReady(ids.Arms_Talent.Skullsplitter, timeShift);
	local sbolt												= ConRO:AbilityReady(ids.Arms_Talent.StormBolt, timeShift);
	local wbreaker, wbCD									= ConRO:AbilityReady(ids.Arms_Talent.Warbreaker, timeShift);
	local cleave 											= ConRO:AbilityReady(ids.Arms_Talent.Cleave, timeShift);
	local avatar 											= ConRO:AbilityReady(ids.Arms_Talent.Avatar, timeShift);
	local dcalm 											= ConRO:AbilityReady(ids.Arms_Talent.DeadlyCalm, timeShift);
	local rend 												= ConRO:AbilityReady(ids.Arms_Talent.Rend, timeShift);
		local rDebuff											= ConRO:TargetAura(ids.Arms_Debuff.Rend, timeShift + 4);
	local ravager											= ConRO:AbilityReady(ids.Arms_Talent.Ravager, timeShift);

--Conditions	
	local targetPh 											= ConRO:PercentHealth('target');
	local canExe											= targetPh <= 25;
	local Close 											= CheckInteractDistance("target", 3);
	
	local castExecute = ids.Arms_Ability.Execute;
		if tChosen[ids.Arms_Talent.Massacre] then
			canExe = targetPh <= 35;
			exe = exe and mexeCD <= 0;
			castExecute = ids.Arms_Talent.MassacreExecute;
		end
	
--Indicators		
	ConRO:AbilityInterrupt(ids.Arms_Ability.Pummel, pummel and ConRO:Interrupt());
	ConRO:AbilityPurge(ids.Racial.ArcaneTorrent, arctorrent and Close and ConRO:Purgable());
	ConRO:AbilityRaidBuffs(ids.Arms_Ability.BattleShout, bshout and not ConRO:RaidBuff(ids.Arms_Ability.BattleShout));
	
	ConRO:AbilityBurst(ids.Arms_Talent.Avatar, avatar and (csCD < 10 or (tChosen[ids.Arms_Talent.Warbreaker] and wbCD < 10)) and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Arms_Ability.Bladestorm, bstorm and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Arms_Talent.Ravager, ravager and ConRO_BurstButton:IsVisible());
	
--Warnings	
	
--Rotations	
	if inChRange and charge then
		return ids.Arms_Ability.Charge;
	end
	
	if ConRO_AoEButton:IsVisible() then
		if sstrikes then
			return ids.Arms_Ability.SweepingStrikes;
		end

		if ssplit and rage < 70 then
			return ids.Arms_Talent.Skullsplitter;
		end
		
		if tChosen[ids.Arms_Talent.Warbreaker] then
			if wbreaker then
				return ids.Arms_Talent.Warbreaker;
			end
		else	
			if csmash then
				return ids.Arms_Ability.ColossusSmash;
			end
		end

		if tChosen[ids.Arms_Talent.Ravager] then
			if ravager and ConRO_FullButton:IsVisible() then
				return ids.Arms_Talent.Ravager;
			end
		else
			if bstorm and ConRO_FullButton:IsVisible() then
				return ids.Arms_Ability.Bladestorm;
			end
		end	

		if cleave and not dwDebuff then
			return ids.Arms_Talent.Cleave;
		end
		
		if mstrike and opBCount == 2 and tChosen[ids.Arms_Talent.Dreadnaught] then
			return ids.Arms_Ability.MortalStrike;
		end

		if exe and ((canExe and (rage >= 40 or csDebuff)) or sdBuff) then
			return castExecute;
		end
	
		if mstrike and ssBuff then
			return ids.Arms_Ability.MortalStrike;
		end	
	
		if ww and csDebuff then
			return ids.Arms_Ability.Whirlwind;
		end
		
		if opower then
			return ids.Arms_Ability.Overpower;
		end		
		
		if ww and rage >= 60 then
			return ids.Arms_Ability.Whirlwind;
		end			
	
	elseif canExe then
		if rend and not rDebuff and not csDebuff then
			return ids.Arms_Talent.Rend;
		end

		if ssplit and rage < 70 then
			return ids.Arms_Talent.Skullsplitter;
		end
		
		if tChosen[ids.Arms_Talent.Warbreaker] then
			if wbreaker then
				return ids.Arms_Talent.Warbreaker;
			end
		else	
			if csmash then
				return ids.Arms_Ability.ColossusSmash;
			end
		end	

		if tChosen[ids.Arms_Talent.Ravager] then
			if ravager and ConRO_FullButton:IsVisible() then
				return ids.Arms_Talent.Ravager;
			end
		else
			if bstorm and ConRO_FullButton:IsVisible() then
				return ids.Arms_Ability.Bladestorm;
			end
		end		

		if mstrike and opBCount == 2 and tChosen[ids.Arms_Talent.Dreadnaught] then
			return ids.Arms_Ability.MortalStrike;
		end

		if opower then
			return ids.Arms_Ability.Overpower;
		end
		
		if exe and (rage >= 40 or csDebuff or sdBuff) then
			return castExecute;
		end
	else
		if rend and not rDebuff and not csDebuff then
			return ids.Arms_Talent.Rend;
		end

		if ssplit and rage < 70 then
			return ids.Arms_Talent.Skullsplitter;
		end
		
		if tChosen[ids.Arms_Talent.Warbreaker] then
			if wbreaker then
				return ids.Arms_Talent.Warbreaker;
			end
		else	
			if csmash then
				return ids.Arms_Ability.ColossusSmash;
			end
		end

		if exe and sdBuff then
			return castExecute;
		end

		if mstrike and not dwDebuff then
			return ids.Arms_Ability.MortalStrike;
		end
		
		if tChosen[ids.Arms_Talent.Ravager] then
			if ravager and ConRO_FullButton:IsVisible() then
				return ids.Arms_Talent.Ravager;
			end
		else
			if bstorm and ConRO_FullButton:IsVisible() then
				return ids.Arms_Ability.Bladestorm;
			end
		end
		
		if opower and opBCount ~= 2 then
			return ids.Arms_Ability.Overpower;
		end
		
		if tChosen[ids.Arms_Talent.FervorofBattle] or ConRO_AoEButton:IsVisible() then
			if ww and rage >= 60 then
				return ids.Arms_Ability.Whirlwind;
			end
		else
			if slam and rage >= 50 then
				return ids.Arms_Ability.Slam;
			end
		end
	end
return nil;
end

function ConRO.Warrior.ArmsDef(_, timeShift, currentSpell, gcd, tChosen)
--Abilities	
	local rcry												= ConRO:AbilityReady(ids.Arms_Ability.RallyingCry, timeShift);
	local dbts 												= ConRO:AbilityReady(ids.Arms_Ability.DiebytheSword, timeShift);
	local vrush 											= ConRO:AbilityReady(ids.Arms_Ability.VictoryRush, timeShift);
		local vBuff												= ConRO:Aura(ids.Arms_Buff.Victorious, timeShift);
	
	local dstance											= ConRO:AbilityReady(ids.Arms_Talent.DefensiveStance, timeShift);
		local defform											= ConRO:Form(ids.Arms_Form.DefensiveStance);
	local ivic	 											= ConRO:AbilityReady(ids.Arms_Talent.ImpendingVictory, timeShift);
	
--Conditions	
	local playerPh 											= ConRO:PercentHealth('player');

--Rotations	
	if tChosen[ids.Arms_Talent.ImpendingVictory] then
		if ivic and playerPh <= 80 then	
			return ids.Arms_Talent.ImpendingVictory;
		end
	else
		if vrush and vBuff then	
			return ids.Arms_Ability.VictoryRush;
		end
	end
	
	if dbts then
		return ids.Arms_Ability.DiebytheSword;
	end
	
	if rcry then
		return ids.Arms_Ability.RallyingCry;
	end
	
	if dstance and not defform then
		return ids.Arms_Talent.DefensiveStance;
	end	
return nil;
end

function ConRO.Warrior.Fury(_, timeShift, currentSpell, gcd, tChosen)
--Resources	
	local rage 												= UnitPower('player', Enum.PowerType.Rage);
	local rageMax 											= UnitPowerMax('player', Enum.PowerType.Rage);

--Racials
	local arctorrent										= ConRO:AbilityReady(ids.Racial.ArcaneTorrent, timeShift);

--Abilities	
	local bt 												= ConRO:AbilityReady(ids.Fury_Ability.Bloodthirst, timeShift + 0.5);
		local eBuff 											= ConRO:Aura(ids.Fury_Buff.Enrage, timeShift);
	local rb 												= ConRO:AbilityReady(ids.Fury_Ability.RagingBlow, timeShift + 0.5);
		local rbCharges											= ConRO:SpellCharges(ids.Fury_Ability.RagingBlow);		
	local charge 											= ConRO:AbilityReady(ids.Fury_Ability.Charge, timeShift);
		local inChRange 										= ConRO:IsSpellInRange(GetSpellInfo(ids.Fury_Ability.Charge), 'target');
	local pummel 											= ConRO:AbilityReady(ids.Fury_Ability.Pummel, timeShift);
	local ramp 												= ConRO:AbilityReady(ids.Fury_Ability.Rampage, timeShift);
	local exe 												= ConRO:AbilityReady(ids.Fury_Ability.Execute, timeShift);
		local mexeCD 											= ConRO:Cooldown(ids.Fury_Talent.MassacreExecute, timeShift);
		local sdBuff 											= ConRO:Aura(ids.Fury_Buff.SuddenDeath, timeShift);	
	local ww 												= ConRO:AbilityReady(ids.Fury_Ability.Whirlwind, timeShift);
		local wwBuff, wwBCount									= ConRO:Aura(ids.Fury_Buff.Whirlwind, timeShift + 2);
	local bshout											= ConRO:AbilityReady(ids.Fury_Ability.BattleShout, timeShift);	
	local reck, reckCD										= ConRO:AbilityReady(ids.Fury_Ability.Recklessness, timeShift);
		local reckBuff 											= ConRO:Aura(ids.Fury_Buff.Recklessness, timeShift);
		
	local fs 												= ConRO:AbilityReady(ids.Fury_Talent.FuriousSlash, timeShift);
		local fsBuff, fsBCount 									= ConRO:Aura(ids.Fury_Buff.FuriousSlash, timeShift + 2);	
	local dr 												= ConRO:AbilityReady(ids.Fury_Talent.DragonRoar, timeShift);
	local bstorm 											= ConRO:AbilityReady(ids.Fury_Talent.Bladestorm, timeShift);
	local cbreaker											= ConRO:AbilityReady(ids.Fury_Talent.Siegebreaker, timeShift);
	
--Conditions	
	local targetPh 											= ConRO:PercentHealth('target');
	local canExe											= targetPh <= 25;
	local Close 											= CheckInteractDistance("target", 3);
	
	local castExecute = ids.Fury_Ability.Execute;
		if tChosen[ids.Fury_Talent.Massacre] then
			canExe = targetPh <= 35;
			exe = exe and mexeCD <= 0;
			castExecute = ids.Fury_Talent.MassacreExecute;
		end

--Indicators	
	ConRO:AbilityInterrupt(ids.Fury_Ability.Pummel, pummel and ConRO:Interrupt());
	ConRO:AbilityPurge(ids.Racial.ArcaneTorrent, arctorrent and Close and ConRO:Purgable());
	ConRO:AbilityRaidBuffs(ids.Fury_Ability.BattleShout, bshout and not ConRO:RaidBuff(ids.Fury_Ability.BattleShout));
	
	ConRO:AbilityBurst(ids.Fury_Ability.Recklessness, reck and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Fury_Talent.Bladestorm, bstorm and ConRO_BurstButton:IsVisible());
	
--Warnings	

--Rotations	
	if inChRange and charge then
		return ids.Fury_Ability.Charge;
	end
	
	if ww and wwBCount ~= 2 and ConRO_AoEButton:IsVisible() then
		return ids.Fury_Ability.Whirlwind;
	end	
	
	if reck and ConRO_FullButton:IsVisible() then
		return ids.Fury_Ability.Recklessness;
	end	
	
	if cbreaker and ConRO_AoEButton:IsVisible() then
		return ids.Fury_Talent.Siegebreaker;
	end		
	
	if ramp and not eBuff and ConRO_AoEButton:IsVisible() then
		return ids.Fury_Ability.Rampage;
	end	

	if dr and ConRO_AoEButton:IsVisible() then
		return ids.Fury_Talent.DragonRoar;
	end
		
	if bstorm and ConRO_AoEButton:IsVisible() and ConRO_FullButton:IsVisible() then
		return ids.Fury_Talent.Bladestorm;
	end	

	if ww and not wwBuff and ConRO_AoEButton:IsVisible() then
		return ids.Fury_Ability.Whirlwind;
	end
	
	if fs and (not fsBuff or fsBCount < 3) then
		return ids.Fury_Talent.FuriousSlash;
	end	
	
	if cbreaker and (reckBuff or reckCD >= 30) then
		return ids.Fury_Talent.Siegebreaker;
	end	
	
	if ramp and (not eBuff or rage >= 95 or reckBuff) then
		return ids.Fury_Ability.Rampage;
	end	
	
	if exe and eBuff and (sdBuff or canExe) then
		return castExecute;
	end
	
	if bt and not eBuff then
		return ids.Fury_Ability.Bloodthirst;
	end	
	
	if rb and rbCharges >= 2 then
		return ids.Fury_Ability.RagingBlow;
	end	

	if bt then
		return ids.Fury_Ability.Bloodthirst;
	end		
	
	if dr and eBuff then
		return ids.Fury_Talent.DragonRoar;
	end
		
	if bstorm and eBuff and ConRO_FullButton:IsVisible() then
		return ids.Fury_Talent.Bladestorm;
	end	
	
	if rb and rage <= 78 then
		return ids.Fury_Ability.RagingBlow;
	end	
	
	if fs then
		return ids.Fury_Talent.FuriousSlash;
	end
		
	if ww then
		return ids.Fury_Ability.Whirlwind;
	end
return nil;
end

function ConRO.Warrior.FuryDef(_, timeShift, currentSpell, gcd, tChosen)
--Abilities	
	local rcry 												= ConRO:AbilityReady(ids.Fury_Ability.RallyingCry, timeShift);
	local eregen											= ConRO:AbilityReady(ids.Fury_Ability.EnragedRegeneration, timeShift);
	local vrush 											= ConRO:AbilityReady(ids.Fury_Ability.VictoryRush, timeShift);
		local vBuff												= ConRO:Aura(ids.Fury_Buff.Victorious, timeShift);

	local ivic	 											= ConRO:AbilityReady(ids.Fury_Talent.ImpendingVictory, timeShift);

--Conditions	
	local playerPh 											= ConRO:PercentHealth('player');
	
--Rotations	
	if tChosen[ids.Fury_Talent.ImpendingVictory] then
		if ivic and playerPh <= 80 then	
			return ids.Fury_Talent.ImpendingVictory;
		end
	else
		if vrush and vBuff then	
			return ids.Fury_Ability.VictoryRush;
		end
	end
	
	if eregen then
		return ids.Fury_Ability.EnragedRegeneration;
	end
		
	if rcry then
		return ids.Fury_Ability.RallyingCry;
	end
	
	return nil;
end

function ConRO.Warrior.Protection(_, timeShift, currentSpell, gcd, tChosen)
--Resources	
	local rage 												= UnitPower('player', Enum.PowerType.Rage);
	local rageMax 											= UnitPowerMax('player', Enum.PowerType.Rage);

--Racials
	local arctorrent										= ConRO:AbilityReady(ids.Racial.ArcaneTorrent, timeShift);
	
--Abilities	
	local taunt 											= ConRO:AbilityReady(ids.Prot_Ability.Taunt, timeShift);
	local revenge 											= ConRO:AbilityReady(ids.Prot_Ability.Revenge, timeShift);
		local rBuff 											= ConRO:Aura(ids.Prot_Buff.Revenge, timeShift);
	local sslam, ssCD										= ConRO:AbilityReady(ids.Prot_Ability.ShieldSlam, timeShift);
	local tclap												= ConRO:AbilityReady(ids.Prot_Ability.ThunderClap, timeShift);
	local pummel 											= ConRO:AbilityReady(ids.Prot_Ability.Pummel, timeShift);
	local intercept 										= ConRO:AbilityReady(ids.Prot_Ability.Intercept, timeShift);
		local inIntRange 										= ConRO:IsSpellInRange(GetSpellInfo(ids.Prot_Ability.Intercept), 'target');	
	local devas 											= ConRO:AbilityReady(ids.Prot_Ability.Devastate, timeShift);
	local bshout 											= ConRO:AbilityReady(ids.Prot_Ability.BattleShout, timeShift);	
	local avatar 											= ConRO:AbilityReady(ids.Prot_Ability.Avatar, timeShift);
		local avBuff 											= ConRO:Aura(ids.Prot_Buff.Avatar, timeShift);
	local sw 												= ConRO:AbilityReady(ids.Prot_Ability.Shockwave, timeShift);
	local demoshout											= ConRO:AbilityReady(ids.Prot_Ability.DemoralizingShout, timeShift);
	local sblock 											= ConRO:AbilityReady(ids.Prot_Ability.ShieldBlock, timeShift);
		local sbCharges											= ConRO:SpellCharges(ids.Prot_Ability.ShieldBlock);
		local sbBuff 											= ConRO:Aura(ids.Prot_Buff.ShieldBlock, timeShift);
	local ipain 											= ConRO:AbilityReady(ids.Prot_Ability.IgnorePain, timeShift);
		local venBuff 											= ConRO:Aura(ids.Prot_Buff.VengeanceIgnorePain, timeShift);
		
	local ravager 											= ConRO:AbilityReady(ids.Prot_Talent.Ravager, timeShift);
	local sb 												= ConRO:AbilityReady(ids.Prot_Talent.StormBolt, timeShift);

--Conditions	
	local ph 												= ConRO:PercentHealth('target');
	local Close 											= CheckInteractDistance("target", 3);
	
--Indicators		
	ConRO:AbilityInterrupt(ids.Prot_Ability.Pummel, pummel and ConRO:Interrupt());
	ConRO:AbilityPurge(ids.Racial.ArcaneTorrent, arctorrent and Close and ConRO:Purgable());
	ConRO:AbilityRaidBuffs(ids.Prot_Ability.BattleShout, bshout and not ConRO:RaidBuff(ids.Prot_Ability.BattleShout));
	ConRO:AbilityTaunt(ids.Prot_Ability.Taunt, taunt and (not ConRO:InRaid() or (ConRO:InRaid() and ConRO:TarYou())));
	
	ConRO:AbilityBurst(ids.Prot_Talent.Ravager, ravager);
	ConRO:AbilityBurst(ids.Prot_Ability.Avatar, avatar and ConRO_BurstButton:IsVisible());

--Warnings	

--Rotations	
	if inIntRange and intercept then
		return ids.Prot_Ability.Intercept;
	end
	
	if ipain and venBuff then
		return ids.Prot_Ability.IgnorePain;
	end
	
	if ConRO_SingleButton:IsVisible() then
		if avatar and ConRO_FullButton:IsVisible() then
			return ids.Prot_Ability.Avatar;
		end
		
		if demoshout and tChosen[ids.Prot_Talent.BoomingVoice] then
			return ids.Prot_Ability.DemoralizingShout;
		end
		
		if sblock and (sslam or ssCD < 2) and not sbBuff and sbCharges >= 2 then
			return ids.Prot_Ability.ShieldBlock;
		end
		
		if sslam then
			return ids.Prot_Ability.ShieldSlam;
		end	
		
		if tclap then
			return ids.Prot_Ability.ThunderClap;
		end		
		
		if revenge and rBuff then
			return ids.Prot_Ability.Revenge;
		end		
		
		if devas and not tChosen[ids.Prot_Talent.Devastator] then
			return ids.Prot_Ability.Devastate;
		end
	else
		if avatar and ConRO_FullButton:IsVisible() then
			return ids.Prot_Ability.Avatar;
		end
		
		if tclap then
			return ids.Prot_Ability.ThunderClap;
		end
		
		if demoshout and tChosen[ids.Prot_Talent.BoomingVoice] then
			return ids.Prot_Ability.DemoralizingShout;
		end
		
		if revenge then
			return ids.Prot_Ability.Revenge;
		end

		if sblock and (sslam or ssCD < 2) and not sbBuff and sbCharges >= 2 then
			return ids.Prot_Ability.ShieldBlock;
		end		
		
		if sslam then
			return ids.Prot_Ability.ShieldSlam;
		end		
	
		if devas and not tChosen[ids.Prot_Talent.Devastator] then
			return ids.Prot_Ability.Devastate;
		end
	end
	return nil;
end

function ConRO.Warrior.ProtectionDef(_, timeShift, currentSpell, gcd, tChosen)
--Resources	
	local rage 												= UnitPower('player', Enum.PowerType.Rage);

--Abilities	
	local swall 											= ConRO:AbilityReady(ids.Prot_Ability.ShieldWall, timeShift);
	local sblock											= ConRO:AbilityReady(ids.Prot_Ability.ShieldBlock, timeShift);
		local sbCharges											= ConRO:SpellCharges(ids.Prot_Ability.ShieldBlock);
		local sbBuff 											= ConRO:Aura(ids.Prot_Buff.ShieldBlock, timeShift);
	local lstand 											= ConRO:AbilityReady(ids.Prot_Ability.LastStand, timeShift);
	local dshout											= ConRO:AbilityReady(ids.Prot_Ability.DemoralizingShout, timeShift);
	local vrush 											= ConRO:AbilityReady(ids.Prot_Ability.VictoryRush, timeShift);
		local vBuff 											= ConRO:Aura(ids.Prot_Buff.Victorious, timeShift);
	local ipain 											= ConRO:AbilityReady(ids.Prot_Ability.IgnorePain, timeShift);
		local ipBuff 											= ConRO:Aura(ids.Prot_Buff.IgnorePain, timeShift);
		
	local ivic 												= ConRO:AbilityReady(ids.Prot_Talent.ImpendingVictory, timeShift);

--Conditions	
	local playerPh 											= ConRO:PercentHealth('player');
	
--Rotations	
	if tChosen[ids.Prot_Talent.ImpendingVictory] then
		if ivic and playerPh <= 80 then	
			return ids.Prot_Talent.ImpendingVictory;
		end
	else
		if vrush and vBuff then	
			return ids.Prot_Ability.VictoryRush;
		end
	end
	
	if lstand and playerPh <= 40 then
		return ids.Prot_Ability.LastStand;
	end
	
	if ipain and not ipBuff then
		return ids.Prot_Ability.IgnorePain;
	end
	
	if sblock and sbCharges >= 2 and ConRO:TarYou() then
		return ids.Prot_Ability.ShieldBlock;
	end
	
	if demo then
		return ids.Prot_Ability.DemoralizingShout;
	end
	
	if swall then
		return ids.Prot_Ability.ShieldWall;
	end
	
	return nil;
end
